//MyExample.java
//Class Example - Aug. 29
//Fall 2012
//Alan Jamieson

//This class provides Java examples for the following:
//    - Variable Declaration
//    - Class definition and instantiation
//    - Use of a Scanner for input
//    - for loop, while loop, for-each, and if statement
//    - Arrays
//    - function definition

import java.util.*;

public class MyExample {

	//various variable declarations
	private Scanner in;
	private int x = 12;
	private float y;
        public int[] myarray;

	//Note, if a variable or function is public, it can be directly
        //accessed outside of the class. If it is private, then it can
        //only be used inside the class itself (not counting main, or
        //other static shenanigans).
	
	//default constructor - sets up the Scanner and array, inits
        //the float.
	public MyExample(){
		in = new Scanner(System.in);
		y = 4.4f;
                myarray = new int[10];
	}

        //nondefault constructor - values for x and y are passed in
        public MyExample(int a, float b){
		x = a;
		y = b;
		in = new Scanner(System.in);
		myarray = new int[10];
	}

	//standard getter
	public int getX(){ return x; }
	
	//toString
	public String toString(){ return y + " " + x; }

	//setter - user input
	public void setY(){
		System.out.print("Enter y value: ");
		y = in.nextFloat();
	}
	
	//setter - random with if
	public void setX(){
		Random r = new Random();
		x = r.nextInt(20);
		if (x % 2 == 1)
			System.out.println("Odd");
		else
			System.out.println("Even");
	}
	
	//random with for
	public void printRandoms(int n){
		Random r = new Random();
		for (int i = 0; i<100; i++){
			System.out.println(r.nextInt(n));
		}
	}

	//array initialization with while
	public void initArray(){
		int i = 0;
		while (i < 10){
			myarray[i] = i;
		}
	}

	//array print with for-each loop
	public void printArray(){
		for(int i : myarray)
			System.out.println(i);
	}

	//main driver
	public static void main(String[] args) {
		//Using the default constructor
		MyExample x = new MyExample();
		System.out.println("Printing X and ToString");
		System.out.println(x.getX());
		System.out.println(x.toString());
		System.out.println("Setting Y");
		x.setY();
		System.out.println("New print with new Y value");
		System.out.println(x.toString());
		System.out.println("Setting X");
		x.setX();
		System.out.println("New print with new X value");
		System.out.println(x.toString());
		System.out.println("Random integer test");
		x.printRandoms(14);

		//Using the nondefault constructor
		MyExample m = new MyExample(14, 34.55f);
		System.out.println("Second instantiation print");
		System.out.println(m.toString());
		System.out.println("Array test");
		m.initArray();
		m.printArray();
	}

}
